require 'erb'
require 'forwardable'

require 'active_record'

require 'monark/context'
require 'monark/schema'
require 'monark/dsl'
require 'monark/migration'
require 'monark/version'

if defined?(Rails)
  require 'monark/railtie'
end

# Monark is a simple migrator.
module Monark

  DEFAULT_MIGRATIONS_FILE_NAME = 'Migrations.rb'
  DEFAULT_ENV = 'development'

  def self.env
    if ENV.key?('MONARK_ENV')
      ENV['MONARK_ENV']
    elsif defined?(::Rails)
      ::Rails.env.to_s
    elsif ENV.key?('RACK_ENV')
      ENV['RACK_ENV']
    else
      DEFAULT_ENV.to_s
    end
  end
end
