module Monark
  
  # The Monark DSL.
  class DSL
    extend Forwardable

    attr_reader :_context

    def initialize(context = nil)
      @_context = context
    end

    def groups(*args, &block)
      groups = args.flatten.compact
      yield if groups.empty? || groups.include?(_context.env.to_sym)
    end
    alias group groups

    def set_version(arg)
      _context.version = arg
    end

    def add(name, options = {}, &block)
      groups(options.fetch(:group, options[:groups])) do
        _context.push Migration.new(_context.root, name, block)
      end
    end

    def load(name, options = {}, &block)
      add(name, options, &block)
      _context.migrations.last.reloadable = true
    end

  end
end